package common

import (
	"testing"
	"time"
)

func TestAccumulatorClean(t *testing.T) {
	t.Parallel()

	now := time.Now()

	acc := &Accumulator{
		ttl: time.Hour,
		values: []*accValue{
			{1, now.Add(-3 * time.Hour)},
			{1, now.Add(-2 * time.Hour)},
			{1, now.Add(-3 * time.Minute)},
			{1, now.Add(-2 * time.Minute)},
			{1, now},
		},
	}

	acc.clean()

	values := acc.values
	if len(values) != 3 {
		t.Fatalf("Expected 3 values in accumulator, got %d", len(values))
	}
}
