package version

import (
	"context"
	"testing"

	"github.com/open-io/oio-exporter/common"
	"github.com/open-io/oio-exporter/testutils"
)

func TestVersionModule(t *testing.T) {
	t.Parallel()

	m := common.MakeMetricData()
	d := MakeDaemon("", "")

	d.versions = []*version{
		{Name: "golden_ratio", Type: "command", Command: "echo 1.618"},
	}

	if err := d.Collect(m); err != nil {
		t.Fatalf("Collect error: %s", err)
	}

	if err := d.Close(context.TODO()); err != nil {
		t.Fatalf("Close error: %s", err)
	}

	testutils.NewMetricDataTest().
		ForMetric(
			testutils.NewMetricAssertion().
				LabelIs("service_type", "golden_ratio").
				LabelIs("version", "1.618").
				NoExtraLabels(),
			"version").
		NoExtraMetrics().
		Check(t, m)
}
